 /* This program generates a mesh with shell elements for the slffea
    finite element code.
    Specialy designed for the arqueometry studies, 
    on ceramics ancient pottery. 

    Updated 22/11/05

    KeraMesh source file
    Version: 1.0
    Copyright (C) 2005 Janos Erzinger

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.
  */



#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <fstream>
#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#define PI 3.1415927

using namespace std;


int nnode;
int i;
int columns;			// mesh control - columns - argument arg1 

// node coordinates
float x;
float y;
float z;
float r;			//raio em z

float alfa = 0;

int nnum = 0;
int linha = 0;
int coluna = 0;

void gera_splines()
{
    system("./script.exec.spline");
}

float d_alfa() // intervalo angular(radianos)-funo do numero de colunasics ancient pottery. */
{
    return ((2 * PI) / columns);
}

int main(int argc, char *argv[])
{
    if (argc == 1) {
	printf("Error - Needs argument - columns number");
	return EXIT_SUCCESS;
    }

    columns = strtol(argv[1], NULL, 10);	// argument one - number of columns
    ofstream objNodes("nodes.dat");

    // spline generation - spline function from gnu plotutils.
    // controls by the script.
    gera_splines();

    FILE *stream_E;		// externo

    stream_E = fopen("E_spline.dat", "r");
    linha = 0;
    alfa = 0;

    // NODES...
    objNodes << "node no., coordinates" << endl;

    while (fscanf(stream_E, "%f %f", &x, &z) != EOF) {

	r = x;

	alfa = 0;

	for (coluna = 0; coluna < columns; coluna++) {

	    x = cos(alfa) * r;
	    y = sin(alfa) * r;

	    objNodes << nnum << "  " << x << "  " <<
		y << "  " << z << endl;

	    nnum++;
	    alfa = alfa + d_alfa();
	}
	linha++;
	objNodes << endl;	// espaco
    }

    fclose(stream_E);

    //---------------------------------
    nnum = 0;
    FILE *stream_I;
    stream_I = fopen("I_spline.dat", "r");

    linha = 0;
    alfa = 0;


    objNodes << endl << endl << "The corresponding top nodes are:" << endl;

    while (fscanf(stream_I, "%f %f", &x, &z) != EOF) {
	r = x;
	alfa = 0;
	for (coluna = 0; coluna < columns; coluna++) {
	    x = cos(alfa) * r;
	    y = sin(alfa) * r;
	    objNodes << nnum << "  " << x << "  " <<
		y << "  " << z << endl;

	    nnum++;
	    alfa = alfa + d_alfa();
	}
	linha++;
	objNodes << endl;
    }

    fclose(stream_I);

    objNodes.close();


    // CORRESPONDING the element nodes

    ofstream objCorresp("corres.dat");

    int numelements = (linha - 1) * (columns);

    int nmat = 1;
    int nmode = 0;
    int integ_flat = 1;

    objCorresp << "numel numnp nmat  nmode  integ_flag This is the vessel"
	<< endl;
    objCorresp << numelements << " " << linha *
	columns << "  " << 1 << "  " << 0 << " " << 1 << endl << endl;

    objCorresp << "matl no., E mod., Poiss., density, Ratio, shear fac." <<
	endl;
    objCorresp << "  0  4.32e8  0.0   9290.0000   0.8333333" << endl <<
	endl;

    objCorresp << " el no., connectivity, matl no" << endl;

    int cont = 0;

    for (i = 0; i < numelements; i++) {

	if (cont == columns - 1) {
	    objCorresp << i << " " << i << " " << i + columns << " " << i +
		1 << "  " << i - columns + 1 << " 0" << endl;
	    cont = 0;
	    objCorresp << endl;
	    continue;
	}

	objCorresp << i << " " << i << " " << i + columns << "  " << i +
	    1 + columns << " " << i + 1 << " 0" << endl;
	cont++;
    }

    objCorresp.close();

    //-----------------------------------------
    // BOUNDARY..
    ofstream objInsert("insert");

    objInsert << "prescribed displacement x: node  disp value" << endl;
    for (i = 0; i <= 19; i++)
	objInsert << i << "  0.0" << endl;
    objInsert << " -10" << endl;

    objInsert << "prescribed displacement y: node  disp value" << endl;
    for (i = 0; i <= 19; i++)
	objInsert << i << "  0.0" << endl;
    objInsert << " -10" << endl;

    objInsert << "prescribed displacement z: node  disp value" << endl;
    for (i = 0; i <= 19; i++)
	objInsert << i << "  0.0" << endl;
    objInsert << " -10" << endl;

    objInsert << " prescribed angle phi x: node angle value" << endl;
    objInsert << " -10" << endl;

    objInsert << " prescribed angle phi y: node angle value" << endl;
    objInsert << " -10" << endl;

    objInsert << "node with point load x, y, z and 2 moments phi x, phi y"
	<< endl;
    for (i = 100; i <= 109; i++)
	objInsert << i << "  0  0  -100  " << " 0.0  0.0" << endl;
    objInsert << " -10" << endl;

    objInsert <<
	"node no. with stress and stress vector in lamina xx,yy,xy,zx,yz"
	<< endl;
    objInsert << " -10" << endl;

    objInsert.close();
    return EXIT_SUCCESS;
}
