/*
    This library function reads data from the input for tetra4.c
    This data represents the initial mesh before it is subdivided.

		Updated 1/16/07

    SLFMESH source file
    Version:  1.4
    Copyright (C) 2007  San Le 

    The source code contained in this file is released under the
    terms of the GNU Library General Public License.
 
*/

#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

extern int triangle_flag, circle_flag;
extern int ne, ndiv;
extern int npel, nsd;

int tetrareader(int *efl, char *name, int ndiv, FILE *o1, double *x, double *y, double *z)
{
	int dof, nmat, nmode, plane_stress_flag, npel2;
	int i,j,dum,dum2,dum3,dum4;
	double fdum1, fdum2, fdum3;
	char text;
	char buf[ BUFSIZ ];

	nmat = 1;
	nmode = 0;
	plane_stress_flag = 0;

	npel2 = 4;
	if( triangle_flag ) npel2 = 3;

	fgets( buf, BUFSIZ, o1 );
	printf( "node no., coordinates \n");

	dum = 0;
	for( i = 0; i < ne; ++i )
	{
	    fscanf( o1,"%d\n", &dum2);
	    printf( "%d\n",dum2);
	    for( j = 0; j < npel; ++j )
	    {
		fscanf( o1, "%lf %lf %lf %d", &x[dum], &y[dum], &z[dum], &efl[dum]);
		printf( "%4d %16.8e %16.8e %16.8e %4d", dum, x[dum], y[dum], z[dum], efl[dum]);
		fscanf( o1,"\n");
		printf( "\n");
		++dum;
	    }
	}

	return 1;
}

